<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Todd Riggins">
   <meta name="GENERATOR" content="Mozilla/4.61 [en] (Win98; I) [Netscape]">
   <title>EXOTICA: SOUND</title>
</head>
<body background="images/exotica_bg.gif" bgcolor="#000000" text="#ffffff">
<center>
<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="maroon"><font size=+2>
<a NAME="SOUND"></a>EXOTICA: SOUND
</font></font></b></center></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="black">
Contents<br>
18 routines<p>
<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_dsound.html#DSOUND_INIT">DSOUND_INIT</A><br>
<A href="e_dsound.html#LOAD_SOUND">LOAD_SOUND</A><br>
<A href="e_dsound.html#PLAY_SOUND">PLAY_SOUND</A><br>
<A href="e_dsound.html#FREE_SOUND">FREE_SOUND</A><br>
<A href="e_dsound.html#DSOUND_RELEASE">DSOUND_RELEASE</A><br>
<A href="e_dsound.html#FREE_DSHWBUFFERS">FREE_DSHWBUFFERS</A><br>
<A href="e_dsound.html#FREE_DSHWBYTES">FREE_DSHWBYTES</A><br>
<A href="e_dsound.html#TOTAL_DSHWBYTES">TOTAL_DSHWBYTES(v1.5)</A><br>
<A href="e_dsound.html#GET_PAN">GET_PAN</A><br>
<A href="e_dsound.html#SET_PAN">SET_PAN</A><br>
<A href="e_dsound.html#GET_VOL">GET_VOL</A><br>
<A href="e_dsound.html#SET_VOL">SET_VOL</A><br>
<A href="e_dsound.html#GET_FREQ">GET_FREQ</A><br>
<A href="e_dsound.html#SET_FREQ">SET_FREQ</A><br>
<A href="e_dsound.html#GET_SWFREQ_MIN">GET_SWFREQ_MIN</A><br>
<A href="e_dsound.html#GET_SWFREQ_MAX">GET_SWFREQ_MAX</A><br>
<A href="e_dsound.html#GET_HWFREQ_MIN">GET_HWFREQ_MIN</A><br>
<A href="e_dsound.html#GET_HWFREQ_MAX">GET_HWFREQ_MAX</A><br>
</font></b></td></tr>
</table>
</font></b></center></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="DSOUND_INIT"></a><center><font color="Maroon">DSOUND_INIT</font></center>
<hr WIDTH="100%">
C: int DSOUND_INIT( ULONG DirectSound_Mode, USHORT Channels, ULONG Sample_Rate, USHORT Bits_Per_Sample ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(DSOUND_INIT,{DirectSound_Mode, Channels, Sample_Rate, Bits_Per_Sample}) <br>
<hr WIDTH="100%">
Description: Initializes DirectX's DirectSound to play sounds.<br>
<hr WIDTH="100%">
DirectSound_Mode Parameter:<br>
* DSSCL_NORMAL : Best cooperation with other applications. This mode is restricted to DirectSound's
default output which is has a Sample_Rate of 22,050 Hz, 2 Channels for Stereo and
8 bits per sample. This means any values you put in the Channels, Sample_Rate and
Bits_Per_Sample parameters will be ignored. <br>
* DSSCL_PRIORITY : This mode might end up changing the output format of another application but the other
DSOUND_INIT parameters will take effect. <br>
* DSSCL_EXCLUSIVE : Grants exclusive use of the device, so applications in
the background are always muted. The other DSOUND_INIT parameters will take effect.<br>
* DSSCL_WRITEPRIMARY : Grants access to the primary buffer for custom mixing.
Background applications are muted. I don't know how to write my own mixer for DirectSound and probably
never will. If you know how, I'll be glad to try to help out if you need very, very specific
functions to access certain DirectX functions better. <p>
Channels Parameter:<br>
1 = Mono<br>
2 = Stereo<p>
Sample_Rate Parameter(The Frequency of the wave):<br>
typically a value of 11025, 22050 or 44100 <p>
Bits_Per_Sample:<br>
a value of 8 for 8-bit format or 16 for 16-bit format. <br>
<hr WIDTH="100%">
Return Value: <br>
0 = success <br>
1 = failure <br>
<hr WIDTH="100%">
C Example: <br>
&nbsp; funcval = DSOUND_INIT(DSSCL_EXCLUSIVE, 2, 44100, 16) <p>
Euphoria Example: <br>
&nbsp; funcval = c_func(DSOUND_INIT,{DSSCL_EXCLUSIVE, 2, 44100, 16}) <br>
<hr WIDTH="100%">
DirectSound in Exotica Tips: <br>    
* DirectSound is optimized for 16-bit samples. There is no performance penalty for changing
Bits_Per_Sample parameter to 16-bit format.<br>
* To improve performance for DirectSound's mixer, keep the Sample_Rate of the wave files
the same as you set the Sample_Rate parameter for. DirectSound will be able to play waves
more quickly if it doesn't have to convert a wave's frequency to match what you specified in the
Sample_Rate parameter.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="LOAD_SOUND"></a><center><font color="Maroon">LOAD_SOUND</font></center>
<hr WIDTH="100%">
C: int LOAD_SOUND( LPSTR Filename, int Sound_ID, int Soundbuffers, int Memory_Mode ) <br> 
<hr WIDTH="100%">
Euphoria Function: c_func(LOAD_SOUND,{Filename, Sound_ID, Soundbuffers, Memory_Mode}) <br> 
<hr WIDTH="100%">
Description: Loads a wave from specified Filename(include path if needed). Sound_ID gives the sound it's
own unique id to use in other Sound routines. The SoundBuffers parameter tells how many times this
sound can be played at one time. Adding more than 1 soundbuffer does NOT take up more memory.
DirectX assigns new pointers to the sound data to give the effect of multiple sounds for the wave.
Set Memory_Mode to 0 to load the sound in software memory.
Set Memory_Mode to 1 to load the sound into the sound card's hardware memory if available. If the
sound card does not have hardware memory, not enough hardware memory for the sound to fit in or
if there is not any hardware memory left, the sound will automatically be loaded into the software memory. <br>
<hr WIDTH="100%">
Retrun Values:<br>
&nbsp; 0 = failure: Not a wave file or the path to the wave file is incorrect.<br>
&nbsp; 1 = Wave file loaded<br>
<hr WIDTH="100%">
Example: <br> 
&nbsp; -- set id for waves <br>
&nbsp; atom SKID <br>
&nbsp; SKID=1 <br>
&nbsp; ... <br> 
&nbsp; -- store the location of the wave file<br>
&nbsp; atom skid<br>
&nbsp; skid = allocate_string("snd/skid.wav") <br> 
&nbsp; ... <br> 
&nbsp; -- Load wave 'skid.wav' with 5 soundbuffers of it's own, the last parameter<br>
&nbsp; -- is set to 1 to load the wave into hardware sound memory if your soundcard<br>
&nbsp; -- supports hardware sound buffers. If not, it will automatically load the wave<br>
&nbsp; -- into a system memory sound buffer.<br>
&nbsp; funcval = c_func( LOAD_SOUND,{ skid, SKID, 5, 1 })<br>
&nbsp; if funcval != 0 then return 1 end if<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="PLAY_SOUND"></a><center><font color="Maroon">PLAY_SOUND</font></center>
<hr WIDTH="100%">
C: int PLAY_SOUND( int Sound_ID, LONG Volume, LONG Pan, DWORD Frequency_Adjust, int Loop ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(PLAY_SOUND,{Sound_ID, Volume, Pan, Frequency_Adjust, Loop}) <br>
<hr WIDTH="100%">
Description: PLAY_SOUND plays the sound specified from the Sound_ID parameter. The Volume parameter
plays the sound at the specfied volume. The Pan parameter plays the sound at the specified pan.
The Frequency_Adjust parameter lets you adjust the frequency from it's original frequency. Setting the
Loop parameter to 0 will play the sound once. Set it to 1 for the sound to be played with an infinit loop.
Volume is in the range of -10000 and 0 which 0 being the loudest. You got me, this is how Microsoft
made it. Anywayz, you probably wont hear anything with a value lower than -4000. So, you might have
to play around with it. If you know the sound is suppose to be totally quite, directly assign it with a value of -10000.
Panning is also wierd. I guess I say this volume and panning stuff is wierd because I came from programming in
DOS and am use to having values of 0 to 255 for volume and pan. Anywayz, a Pan value of 0 is center, -10000
is the max to the left and 10000 is the max to the right, well, occurding to the DirectX 7.x headers it is.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="FREE_SOUND"></a><center><font color="Maroon">FREE_SOUND</font></center>
<hr WIDTH="100%">
C: void FREE_SOUND( int Sound_ID ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(FREE_SOUND,{Sound_ID}) <br>
<hr WIDTH="100%">
Description: FREE_SOUND will free up the memory used by the specified sound. You don't have to call
this routine because the EXOTICA_EXIT routine will free up any sounds that are currently being used.
This routine can be used to free up sound memory when certain sounds are no longer needed in the
program in which it will help keep the memory requiments for your program lower for example.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="DSOUND_RELEASE"></a><center><font color="Maroon">DSOUND_RELEASE</font></center>
<hr WIDTH="100%">
C: int DSOUND_RELEASE( void ) <br>  
<hr WIDTH="100%">
Euphoria Function: c_func(DSOUND_RELEASE,{NULL}) <br>  
<hr WIDTH="100%">
Description: Frees DirectSound from memory which was initialized with DSOUND_INIT.
Note: You don't have to call this routine. EXOTICA_EXIT will make sure
DirectSound is released. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="FREE_DSHWBUFFERS"></a><center><font color="Maroon">FREE_DSHWBUFFERS</font></center>
<hr WIDTH="100%">
C: DWORD FREE_DSHWBUFFERS( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(FREE_DSHWBUFFERS,{NULL}) <br>
<hr WIDTH="100%">
Description: returns the amount of free DirectSound hardware buffers.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="FREE_DSHWBYTES"></a><center><font color="Maroon">FREE_DSHWBYTES</font></center>
<hr WIDTH="100%">
C: DWORD FREE_DSHWBYTES( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(FREE_DSHWBYTES,{NULL}) <br>
<hr WIDTH="100%">
Description: returns the amout of free DirectSound hardware memory in bytes.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TOTAL_DSHWBYTES"></a><center><font color="Maroon">TOTAL_DSHWBYTES(v1.5)</font></center>
<hr WIDTH="100%">
C: DWORD TOTAL_DSHWBYTES( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(TOTAL_DSHWBYTES,{NULL}) <br>
<hr WIDTH="100%">
Description: returns the total amout of DirectSound hardware memory in bytes.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_PAN"></a><center><font color="Maroon">GET_PAN</font></center>
<hr WIDTH="100%">
C: LONG GET_PAN( int Sound_ID ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_PAN,{Sound_ID}) <br>
<hr WIDTH="100%">
Description: returns the current panning value from the specified sound.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_PAN"></a><center><font color="Maroon">SET_PAN</font></center>
<hr WIDTH="100%">
C: void SET_PAN( int Sound_ID, LONG Pan_Value ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(SET_PAN,{Sound_ID, Pan_Value}) <br>
<hr WIDTH="100%">
Description: Set the specified sound to a new pan value.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_VOL"></a><center><font color="Maroon">GET_VOL</font></center>
<hr WIDTH="100%">
C: LONG GET_VOL( int Sound_ID) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_VOL,{Sound_ID}) <br>
<hr WIDTH="100%">
Description: returns the current volume value from the specified sound.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_VOL"></a><center><font color="Maroon">SET_VOL</font></center>
<hr WIDTH="100%">
C: void SET_VOL( int Sound_ID, LONG Volume_Value ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(SET_VOL,{Sound_ID, Volume_Value}) <br>
<hr WIDTH="100%">
Description: Set the specified sound to a new volume value.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_FREQ"></a><center><font color="Maroon">GET_FREQ</font></center>
<hr WIDTH="100%">
C: LONG GET_FREQ( int Sound_ID ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_FREQ,{Sound_ID}) <br>
<hr WIDTH="100%">
Description: returns the current frequency value from the specified sound.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_FREQ"></a><center><font color="Maroon">SET_FREQ</font></center>
<hr WIDTH="100%">
C: void SET_FREQ( int Sound_ID, LONG Freq_Value ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(SET_FREQ,{Sound_ID, Freq_Value}) <br>
<hr WIDTH="100%">
Description: Set the specified sound to a new frequency value.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_SWFREQ_MIN"></a><center><font color="Maroon">GET_SWFREQ_MIN</font></center>
<hr WIDTH="100%">
C: DWORD GET_SWFREQ_MIN( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_SWFREQ_MIN,{NULL}) <br>
<hr WIDTH="100%">
Description:<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_SWFREQ_MAX"></a><center><font color="Maroon">GET_SWFREQ_MAX</font></center>
<hr WIDTH="100%">
C: DWORD GET_SWFREQ_MAX( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_SWFREQ_MAX,{NULL}) <br>
<hr WIDTH="100%">
Description:<p> 
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_HWFREQ_MIN"></a><center><font color="Maroon">GET_HWFREQ_MIN</font></center>
<hr WIDTH="100%">
C: DWORD GET_HWFREQ_MIN( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_HWFREQ_MIN,{NULL}) <br>
<hr WIDTH="100%">
Description:<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_HWFREQ_MAX"></a><center><font color="Maroon">GET_HWFREQ_MAX</font></center>
<hr WIDTH="100%">
C: DWORD GET_HWFREQ_MAX( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_HWFREQ_MAX,{NULL}) <br>
<hr WIDTH="100%">
Description:<p> 
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>

</center>
</body>
</html>
